import { ApiProperty } from "@nestjs/swagger"
import { ChallengeAction } from "@prisma/client"
import { ChallengeEntity } from "src/challenges/entities/challenge.entity"

export class ChallengeActionEntity implements ChallengeAction {
  constructor(partial: Partial<ChallengeActionEntity>) {
    Object.assign(this, partial)
    if (this.challenge) {
      this.challenge = new ChallengeEntity(this.challenge)
    }
  }

  @ApiProperty({ description: "Identifiant unique" })
  id: number

  @ApiProperty({ description: "Identifiant de l'utilisateur⋅rice effectuant le défi" })
  userId: number

  @ApiProperty({ description: "Identifiant du défi rattaché à l'action" })
  challengeId: number

  @ApiProperty({ type: ChallengeEntity, description: "Défi rattaché à l'action", nullable: true })
  challenge?: ChallengeEntity | null

  @ApiProperty({ description: "Est-ce que le défi est actuellement en train d'être réalisé" })
  active: boolean

  @ApiProperty({ description: "Est-ce que le défi a été réussi" })
  success: boolean
}
